/* zpellin < liste_mots > table */

#include "epelle.h"

#define C(a) ((char) a)
#define LOW(a) (a & 0xFF)
#define HIGH(a) ((a & 0xFF00)>>8)
#define VHIGH(a) ((a & 0x70000)>>16)
#define ERROR(s) {fprintf(stderr,"s\n"); exit(1);}

typedef struct NOEUD {
    char c,existe;
    struct NOEUD *fils,*frere;
} noeud;

noeud type_noeud[MAX_NODES];
int hashtab[PRIME];
int nb_noeuds=0,nb_types=0,traites=0;

noeud* nouveau_noeud(cc)
char cc;
{
    noeud *t;

    t = (noeud*) malloc(sizeof(noeud));
    if (t==0) ERROR(ran out of memory)
    t->c = cc;  t->existe = 0;  t->fils = t->frere = NULL; ++nb_noeuds;
    return(t);
}

#ifdef MSDOS
main(argc, argv)
    int             argc;
    char           *argv[];
#else
main()
#endif
{
    noeud *root,*t;
    char cc;
#ifdef MSDOS
    char           *prog;
#endif
    int nb_mots=0,i;

#ifdef MSDOS
    if ((prog = (char *) rindex(argv[0], '/')) != NULL)
	{prog++;prog[strlen(prog) - 4] = NULL;};
    if (argc != 3) {
	fprintf(stderr, "%s (usage) : %s liste_mots table\n", prog, prog);
	exit(3);
    };
    if (freopen(argv[1], "r", stdin) == NULL) {
	fprintf(stderr, "%s : Impossible d'ouvrir %s\n",prog, argv[1]);
	exit(3);
    };
    if (freopen(argv[2], "wb", stdout) == NULL) {
	fprintf(stderr, "%s : Impossible d'ouvrir %s\n", prog,argv[2]);
	exit(3);
    };
#endif
    t = root = nouveau_noeud('?');
    while ((cc = getchar()) != (char)EOF) {
	if ((unsigned)cc>' ') {
	  cc = tolower(cc);
	  if (t->fils != NULL) {
	   t = t->fils;
	   while (t->c != cc)
	       if (t->frere != NULL) t = t->frere;
	       else t = t->frere = nouveau_noeud(cc);
          }
	  else t = t->fils = nouveau_noeud(cc);
	}
	else { 
	    t->existe = 1;  ++nb_mots;  t = root; 
	}
    }
    fprintf(stderr,"%d words, %d nodes, ",nb_mots,nb_noeuds);
    for (i=0;i<PRIME;i++) hashtab[i]=0;
    compactifie(root);
    fprintf(stderr,"%d nodes after compaction\n",nb_types);
    out();
    exit(0);
}

int hash (fi,fr,c,b)
int fi,fr;
char c,b;
{
    return(I(16061*fi + 16063*fr + 16067*I(c) + 16069*I(b)) % PRIME);
}

int cherche(fi,fr,c,b)
int fi,fr;
char c,b;
{
    int h,i;

    h = hash(fi,fr,c,b);
    while (hashtab[h] != 0) {
	i = hashtab[h];
	if (I(type_noeud[i].fils) == fi)
	    if (I(type_noeud[i].frere) == fr)
		if (type_noeud[i].c == c)
		    if (type_noeud[i].existe == b)
			return(i); /* trouve' */
	h = (h+1) % PRIME;
    }
    hashtab[h] = ++nb_types;
    return(-1); /* non trouve' */
}

int compactifie(t)
noeud *t;
{
    int type_frere, type_fils,i;

    if (t == NULL) return(0);
    else {
	traites++;
	type_frere = compactifie(t->frere);  type_fils = compactifie(t->fils);
	i = cherche(type_fils,type_frere,t->c,t->existe);
	if (i != -1) return(i);   /* sous-arbre de'ja` rencontre' */
	i = nb_types;
	if (i>=MAX_NODES) 
	    {fprintf(stderr,"too many compacted nodes : %d/%d\n",traites,nb_noeuds); exit(1);}
	type_noeud[i].c = t->c;  type_noeud[i].existe = t->existe;
	type_noeud[i].fils = (noeud*) type_fils;
	type_noeud[i].frere = (noeud*) type_frere;
	return(i);
    }
}

out() /* e'crit la table compacte'e en stdout   */
/* format : 6 octets par enregistrement         */
/*      0 : caracte`re                          */
/*      1 : boole'en + 3 bits + 3 bits vhigh    */
/*      2 : fils low                            */
/*      3 : fils high                           */
/*      4 : frere low                           */
/*      5 : frere high                          */
/* la racine est le dernier enregistrement      */
{
    int i,j,k;

    for (i=1; i<=nb_types; i++) {
	putchar(type_noeud[i].c);
	k = I(type_noeud[i].existe) + (VHIGH(I(type_noeud[i].fils))<<1)
	    + (VHIGH(I(type_noeud[i].frere))<<4);
	putchar(C(k));
	putchar(C(LOW(I(type_noeud[i].fils))));
	putchar(C(HIGH(I(type_noeud[i].fils))));
	putchar(C(LOW(I(type_noeud[i].frere))));
	putchar(C(HIGH(I(type_noeud[i].frere))));
    }
}
